#ifndef __DATA_HPP_INCLUDED__
#define __DATA_HPP_INCLUDED__

#include <vector>
#include <stdint.h>
#include <array>

// Three types ave been added :
// 1. Images (Sensor RAW - 14b * 4 * 1920 *1080 = )

template <class T>

struct Image {
    typedef unsigned short int camera_pixel_depth; // 12-14 bits pel stored as a 16 bits datatype (some optimisation could be done
    const size_t kPixelCount = 8294400; //1920*1200*4;
    std::array<camera_pixel_depth,8294400> data ;

    Image(){

            for (int i = 0; i < data.size(); ++i )
            {
                data[i]=i;
            }
        }
};

// 2. PointCloud (300k points = 1GB data)
struct PointCloud {
    typedef struct pointcloud { float x[3]; } pointcloud;

    const size_t kPointsCount = 300000;
    std::array<pointcloud,300000> data ;

    PointCloud(){
        for (int i = 0; i < data.size(); ++i )
        {
         data[i]= {i,i,i};
        }
    }

};

// Strings
const size_t      kStringsCount = 100;
const std::string kStringValue  = "shgfkghsdfjhgsfjhfgjhfgjsffghgsfdhgsfdfkdjhfioukjhkfdljgdfkgvjafdhasgdfwurtjkghfsdjkfg";

// Integers
const std::vector<int64_t> kIntegers = {
    -7363025924956902506, 433747491,            -1063289711,
    -3099617426797642053, -10,                  -28373,
    56,                   -26152,               11187,
    16848,                52,                   21,
    -1507434656,          -40,                  1817515017,
    1733359561,           34,                   -5848022735330443435,
    -2877218739042719860, -14312,               23,
    -26,                  -13627,               206,
    6171277796506625478,  937414961,            -9891,
    -122,                 519378804,            79,
    8,                    34,                   -6130140954141921706,
    -73,                  -616005134,           -5037253190769578767,
    0,                    -1722533411,          -654047289,
    -5814,                -257712663,           -87,
    -6247856385486233498, 4742432808147022328,  -810583170,
    -22,                  6569946999860187637,  -22276,
    -2172499325432780121, -898744892,           1882785313,
    67,                   -845249652572657056,  -103,
    -1713893920,          -803649978604894042,  -368771773,
    -2885635929107858908, 24954,                1357532846405761876,
    769985138,            -6727,                3466300259955127320,
    2230714975058449906,  -13476,               -19,
    84,                   -25529,               7199838975151841639,
    34,                   1326261707,           -2163,
    -8638513271658874509, -1065570052,          -678072504,
    544751144,            118,                  -1628126727,
    122,                  -124,                 -64,
    -12790,               559970209,            -18411,
    36,                   -98453689293414928,   2381030868204480509,
    -4220,                8994822118835925427,  25947,
    -994516429,           29735,                -75,
    -16257,               1755158791,           1931770885540470507,
    -114,                 503040442223125581,   -5642282595025354408,
    501831335,            -49,                  -794973920,
    18,                   7198923596506520233,  -15162,
    8864,                 25625,                -8256,
    -630542150,           28541,                -100,
    -92,                  -7986092697978475564, 3175680640580073309,
    -1454692424,          -31891,               -63,
    -103,                 8487358384832003816,  -23,
    -589490175,           -5552032683325052704, -64,
    -80,                  -838179120,           8947214309209989793,
    -77,                  -7411189781173852711, -11697,
    13436,                1815247385,           -2981,
    -8003717504228034722, 99,                   -3257811286542676197,
    -4506293477750347316, -2711,                6160405628721311283,
    5,                    -1484233804362552782, -17226,
    1402014380,           733176135,            -100,
    4500917704953902996,  18,                   4866887786818606461,
    -16225,               71,                   -22197,
    2405053731958747752,  -5274,                -2090003371,
    369436529,            1358574860523487735,  -319773871,
    16641,                5063075396589477179,  52,
    -21466,               -81335356,            -119208745560659154,
    21924,                -1047970083662342224, -11013,
    76,                   2903978634660040404,  -101,
    6916945980630884447,  -1303492917515564855, 5637,
    2248,                 -2030728347,          64,
    7925,                 -21779,               8123127443689130000,
    1417036646,           -39040821,            117123230,
    -32,                  -3724,                -6344211701431602973,
    -438193563,           -113,                 -1926548125,
    28729,                -15,                  282434333,
    7871549853186581381,  -433592745,           -1055677683,
    17987,                -83,                  7754104478641525815,
    613327974,            14303,                -8140203062797588352,
    1586717809361568140,  -7393582019467132139, 5126447447975253192,
    1048,                 -1043188811128220318, 107,
    65,                   -4172277813576501980, 14,
    35,                   26,                   -1236985343,
    -15929,               -15216,               878309091,
    -56,                  -2011310606,          16389,
    660901290,            -1862266658167057059, -2323661464700608064,
    1791007818,           -5279836060148389134, -5205385764500646601,
    -10347,               1193594059,           8052063426113313885,
    244985862,            -7077002144560125490, -8930213132096048131,
    -78,                  -27,                  -16260,
    -3414386987451750431, 756976161,            -1709959030,
    -960927998945600368,  -141710072,           23461,
    -7185717208481827041, -89,                  -120,
    -1307393865,          27698,                -14165,
    -1172826903,          -8622113791680402438, -9400,
    8808312621540105568,  -4020327146569329755, 30976,
    1866740273,           -8231,                316317859,
    1805393137,           485604266,            72,
    2454665038702183726,  2094270224,           5686021805018713204,
    -24844,               20365,                -4282662953797348809,
    -4566794532077649548, -6280124553363717403, -50,
    32,                   1872404256,           -89,
    316075246,            -26268,               -4964651049131855299,
    -112,                 -8641327509012147836, -766536697,
    5993067092994742370,  1988899656,           1987725073,
    -19950,               -1893302419775054285, 121,
    48,                   1948768928,           53,
    -5243,                8738685391165513812,  365750484,
    -93,                  -671864471,           706255199,
    -8152,                83,                   -99,
    -9,                   -3788717718769360742, 1307431297108392162,
    30,                   8716,                 1436862582,
    676135215,            22558,                -122,
    2522141144230140132,  5576475,              -758518299,
    147370106,            4988483904228877116,  947995246,
    1659982684302768005,  -22312,               -48,
    62,                   79,                   8537214179102424324,
    -997135172,           875051761,            -4848592808270937156,
    -7697574980447404268, -37,                  -38,
    -1242,                313438480,            11749,
    -2986,                2030066008,           45,
    1395369669,           1700476845,           -20,
    -1287110890,          -90,                  1508574604756731954,
    -26092,               -3939205815465530879, -1187773708119651248,
    -25834,               -1206523470,          -53,
    -1592661607326053524, 18212,                -33,
    -41,                  84266565,             -2,
    571521241,            -1636475055566264497, 891431496,
    23912,                10555,                30153,
    8030521545404037952,  -6374825163279815327, 99,
    5241879833101903522,  -1882027021007931225, 2040976134,
    -3793021618212331483, 83,                   5696250655933345190,
    1925480131260232953,  9358,                 -22648,
    25575,                -648216540,           -5019755232846076450,
    18622,                97,                   554376950,
    21886,                -54,                  2494996710999596835,
    -68,                  18589,                40,
    -177650370,           -74,                  6270,
    7538349603945271910,  25441,                -893046314,
    -276550117,           -74,                  -1427284664,
    -1049203211,          1869751501,           1213046221332824865,
    -1043880054,          8765925747447038140,  -370820427,
    -5345471357868845747, -26330,               -1155922900,
    -18875,               -7601800821521096438, -111,
    -36,                  -12,                  5533825000284329250,
    5580,                 27733,                -381021541,
    1178839104,           449775459,            -103,
    2050845098,           -7540,                -56,
    -928281908,           -20046,               -39,
    13864,                -14159,               -6270095092780779000,
    351242396,            -12,                  22,
    29,                   -5852080089825335588, -608640126283793658,
    -474696155,           -16,                  -1714338066,
    565158960,            17722,                3807577336920137242,
    21464,                -117,                 -1769932179,
    -6041961534343242191, -30,                  12353,
    -21,                  -6687,                1870487103,
    24573,                12314,                4684252076755731050,
    -5659,                27965,                91,
    -167679051461621384,  -2617986404823401218, 5732516693149630710,
    9355,                 4644,                 -120,
    1635415463,           361922141231153413,   2466639219506760025,
    21393,                7213002110551451773,  3033342980902020619,
    -31,                  -7137143647102241872, 16,
    -69,                  6,                    1789633802,
    -1170546172,          111,                  55,
    -17896,               -13714,               4026166599181052037,
    23950776344086454,    65,                   -2856,
    -23465,               31786,                1312811083154161657,
    30348,                -1361598898,          5359,
    72,                   -10252,               8623,
    632949786950606955,   -1229307629,          8293273260624578598,
    29463,                1567105724,           -3707,
    -28435,               1074126623,           2034633745,
    2083185667,           -5710229132046966643, -25357,
    1832738019,           4309,                 -4631,
    -9301,                20237,                -596,
    959424841,            -5528099178530169963, 116,
    -30632,               -1106867457977143514, -1475677156535008452,
    31293,                -16109,               -2193967216581540557,
    -23002,               2427339250189791946,  1679407924,
    6051529596673312178,  -17,                  8544,
    8459,                 -88,                  -1725552087,
    1285,                 26448,                28484,
    -17,                  -41,                  8369898813248345434,
    -2708157913359168058, 21622,                57,
    -7398224664586362004, 28570,                -6474382546613242389,
    31,                   17798,                -1863510699,
    -5518,                111,                  -1553296730,
    448310778,            -8772569120406406086, 15990,
    -28920,               -22497,               -11057,
    -103,                 587231746,            -2038804459132069098,
    4613338714938013216,  108,                  -5615213890232996984,
    -936055357,           -1065383251,          -2294510694869443495,
    -1477126894,          -1673055163,          -14284,
    25051,                -3986940435767480559, 6041752349511510486,
    8041915042501314792,  -3985160511342754585, -4028224886874105532,
    1052206264681358951,  -3481428206376095861, -46,
    11550,                -44,                  -2079227272,
    8719067110551671946,  1288444037,           -25143,
    13602,                18,                   21291,
    93,                   -23,                  -196800021,
    809571975,            -31727,               8763,
    -661706897555808507,  119,                  31046,
    -609547460,           23341,                -60,
    6086126050563937403,  1895635109952004787,  -13995,
    -242886322,           8,                    18,
    -8976496123608892670, -79,                  -7244,
    2339688347224492944,  1104183683,           -41,
    -18494,               -971434129,           8642919108023816312,
    21499,                28530,                70,
    17290,                -840331438133652510,  1976117116,
    1570886366568950127,  -101,                 -4534101121505215989,
    20200,                -63,                  -272652970,
    -28978,               -349332691866139426,  -25699,
    -1462205442,          580911690,            -6992751044112263311,
    -107,                 -4575786221323014929, -195654910,
    24,                   -3835604712339792761, 1891312992,
    3828669121105386371,  124,                  -361586698,
    -937894193,           -993613123,           28859,
    -15,                  5009707794877239135,  -223733485,
    -1721452461,          574309197,            4782,
    97,                   85,                   -1171035587590439385,
    8312,                 -927867487,           -1292683344,
    11282,                -125,                 27129,
    -10222,               -4880,                -1792231338,
    3758318694067395058,  -55,                  -84,
    -22923036,            4120698313340693392,  -350,
    -1899045160,          6349610473498904829,  -60,
    -7222845473356938029, 1047951567,           -440818821,
    -1537767148,          -88,                  25578,
    -115,                 -243999549,           -89,
    -5312811593689077629, -103,                 26,
    -5027457524326464514, -721685921,           39,
    -1362543574,          -7795,                -46,
    1218271119,           30705,                -17514,
    -23702,               6734,                 6840,
    1667317608,           -1661745750,          4,
    8033680933281782118,  13401,                -70,
    1676130015,           -2938419533750020834, -106,
    -27755449,            -29397,               -4929554532967162102,
    -9622,                -14823,               3772308820372273715,
    807060921,            -70,                  -22540,
    295102169980408575,   95,                   -11,
    88,                   14465,                -6365560894511598451,
    2012336419,           -22616,               -1459870277,
    -2042522915,          118,                  -9980,
    1777954039,           -882129585,           -2656396557369034721,
    3781997027662552168,  -1168752842,          3148967521842022774,
    -1313696289,          -37,                  -343582862,
    1874767111,           -3112175777304194208, 7806167555058347392,
    100,                  -1895288719,          28,
    -26159,               112,                  -30987,
    10776,                5232434611274207549,  -21024,
    -4483430693608459193, -345575112,           -5917612984938832379,
    27328,                6730667831210033901,  -2809111713636358967,
    -12131,               4822,                 26781,
    1764874174431404362,  -5,                   13527,
    7051481596943853310,  1610476985,           8720,
    -20287,               -2316801172356721072, -2912299227084801965,
    106,                  30330,                6618,
    -17862,               31142,                386494837,
    52,                   -494106843,           83,
    -27348,               -7719,                19660,
    886520682,            8960,                 31956,
    7796428150878326604,  8017588419220571056,  -541019595,
    -26284,               -63,                  -7344218109931640833,
    106,                  -2011965846,          69,
    -7361118335520743856, -27,                  111,
    7024055925625955713,  -27008,               27548,
    -724609890,           -54,                  -1377801640,
    1220470256,           -6671358653627050578, 1408981531,
    -17834,               -29778,               2154,
    -1147751355,          -1244589537,          18,
    -8995,                1323880117,           4826,
    3738,                 -8381527448310097033, 880564802,
    -18758,               -2007492304,          124,
    4071608576664398793,  1334705552,           -883131665,
    33,                   -2784068839981465237, -37,
    -3292250044805079221, 111,                  115,
    -505824416,           -1329516325,          6863,
    -4161,                -1484254646,          -1647742965,
    -684154112,           111,                  441361943,
    -6617,                1161471919,           -29,
    305662650,            -1681699761,          44,
    -1583862705295675197, -12,                  -1474320271,
    7936,                 -917167826,           -3860079915840664976,
    -25661,               3477085156689013266,  42,
    -22,                  -539422308,           -16010,
    613115140,            -69,                  410916790,
    -17638,               304410071,            1930928152,
    -30701,               -2531841024167117027, 28606,
    3307060987245058821,  108,                  -82,
    -2122172733037128428, -30691,               3251187856144995874,
    520138362,            13352,                -1406753793,
    -12,                  -1553003040463479123, -424,
    41,                   -7233602940428378715, 7686418650162863126,
    -78,                  -5181978843372623165, -4271415536440906941,
    -31167,               -64,                  25,
    36,                   -56,                  33,
    1537572386,           52,                   109,
    -88,                  -6332157348037570723, -9438,
    7636254448930979739,  2233977254874917251,  7657,
    2155349169311562054,  1166413491,           7444722622948486608,
    69,                   117,                  27307,
    -44,                  -187114342,           -20777,
    1478383894,           -3599951908972507624, 1641800999,
    -2645721906112636821, 6021605908604371589,  7303492435488755034,
    1434331208,           1090637426,           5897,
    68708828,             1529684989,           -120,
    -3,                   10317,                -70,
    1787,                 103,                  43,
    7692320002016645775,  13556915,             -3414,
    1406705089,           -303493095,           -72,
    141171389,            8086501342466353726,  -20791,
    91,                   691745374,            908599936,
    -31,                  14639,                -60,
    78,                   -86,                  6603823110258632713,
    -618490520,           -1693031242,          -3933,
    -53,                  2453457273625938952,  3902407010405367825,
    571240036,            121,                  -39,
    -154065643,           606326497545505818,   33,
    -1684204429,          -2351,                -21,
    104,                  7409,                 10084,
    -1859407104,          7161074596731158945,  54,
    -15176,               85,                   8542258976263311155,
    -510822799,           2634223587363843425,  -838882481452157821,
    2085654442476583674,  -7271513813046190366, 2971023759308078566,
    48,                   -534232402,           121,
    1676343143,           105,                  739395768,
    -56,                  2633309473271351540,  101,
    -669904691,           4664,                 34,
    20,                   2838549427757326550,  -5628,
    -98,                  -4576588524518425817, 112,
    -8274461191016336405, -13461,               -58,
    -195317548,           85,                   -11575,
    1346208021602232582,  1133160616,           -1128900985,
    -3003,                26,                   -101,
    -82,                  -1951476431,          -14,
    -6604659608414297734, -19725,               45,
    -8721911835838330030, 99,                   -19640,
    -763002527307034193,  -1373418318317290504, -2,
    0,                    -4267535866276109679, -12369,
    -1482097641,          -1211973318,          -8156336852661611782,
    58226505165754587,    1862931288479886958,  83,
    -10440,               -33,                  -18991,
    -102
};

#endif
